package windsock;

import windsock.*;
import java.net.*;
import java.io.*;

public class BindHandler extends Thread {
    protected ServerSocket listener = null;
    protected Socket client = null;
    protected Socket server = null;

    public BindHandler(Socket client, Request r)
	    throws SocksException {
	this.client = client;
	Log.log("new BindHandler(" + client + ", " + r + ")");
	try {
	    listener = new ServerSocket(0);
	} catch (IOException e) {
	    throw new SocksException(SocksSocket.REPLY_FAIL);
	}
	r.addressType = SocksSocket.ATYP_IPV4;
	r.address = getOutsideAddress().getAddress();
	r.port = getOutsidePort();
    }

    public void accept(Request r) throws SocksException {
	try {
	    server = listener.accept();
	} catch (IOException e) {
	    throw new SocksException(SocksSocket.REPLY_FAIL);
	}
	r.addressType = SocksSocket.ATYP_IPV4;
	r.address = server.getInetAddress().getAddress();
	r.port = server.getPort();
    }

    public InetAddress getOutsideAddress() {
	try {
	    return InetAddress.getLocalHost();
	} catch (UnknownHostException e) {
	    Log.err("What the FUCK!");
	    return null;
	}
	//return listen.getInetAddress();
    }

    public int getOutsidePort() {
	return listener.getLocalPort();
    }

    public void run() {
	Semaphore sem = new Semaphore(0);
	// TODO: check if the guy we're expecting is the one who connects
	Thread toClient = null, toServer = null;
	try {
	    toClient = new Forward(sem, server.getInputStream(),
		    client.getOutputStream());
	    toServer = new Forward(sem, client.getInputStream(),
		    server.getOutputStream());
	} catch (IOException e) {
	    try {
		client.close();
		server.close();
	    } catch (Exception f) {}
	    Log.err(e);
	    return;
	}

	Log.log("Starting Forward threads...");
	toClient.start();
	toServer.start();
	Log.log("Started Forward threads.");

	/* Block until one of the threads finishes. */
	sem.p();
	Log.log("Got semaphore.");

	try { client.close(); } catch (IOException e) {}
	try { server.close(); } catch (IOException e) {}
    }
}
