package windsock;

import windsock.*;
import java.net.*;
import java.io.*;

public class ConnectHandler extends Thread {
    protected Socket client = null;
    protected Socket server = null;

    public ConnectHandler(Socket client, Request r)
	    throws SocksException {
	this.client = client;
	Log.log("new ConnectHandler(" + client + ", " + r + ")");
	try {
	    server = new Socket(Util.resolve(r.addressType, r.address), r.port);
	} catch (UnknownHostException e) {
	    throw new SocksException(SocksSocket.REPLY_HOST_UNR);
	} catch (ConnectException e) {
	    throw new SocksException(SocksSocket.REPLY_REFUSED);
	} catch (NoRouteToHostException e) {
	    throw new SocksException(SocksSocket.REPLY_HOST_UNR);
	} catch (SocketException e) {
	    throw new SocksException(SocksSocket.REPLY_FAIL);
	} catch (IOException e) {
	    throw new SocksException(SocksSocket.REPLY_FAIL);
	}
	Log.log("connected to " + server);
	r.addressType = SocksSocket.ATYP_IPV4;
	r.address = getOutsideAddress().getAddress();
	r.port = getOutsidePort();
    }

    public InetAddress getOutsideAddress() {
	try {
	    return InetAddress.getLocalHost();
	} catch (UnknownHostException e) {
	    Log.err("What the FUCK!");
	    return null;
	}
	//return listen.getInetAddress();
    }

    public int getOutsidePort() {
	return server.getLocalPort();
    }

    public void run() {
	Log.log("Starting connection manager. client=" + client +
		", server=" + server);

	Semaphore sem = new Semaphore(0);
	// TODO: check if the guy we're expecting is the one who connects
	Thread toClient = null, toServer = null;
	try {
	    toClient = new Forward(sem, server.getInputStream(),
		    client.getOutputStream());
	    toServer = new Forward(sem, client.getInputStream(),
		    server.getOutputStream());
	} catch (IOException e) {
	    try {
		client.close();
		server.close();
	    } catch (Exception f) {}
	    Log.err(e);
	    return;
	}

	Log.log("Starting Forward threads...");
	toClient.start();
	toServer.start();
	Log.log("Started Forward threads.");

	/* Block until one of the threads finishes. */
	sem.p();
	Log.log("Got semaphore.");

	try { client.close(); } catch (IOException e) {}
	try { server.close(); } catch (IOException e) {}
    }
}
