package windsock;

import windsock.*;
import java.net.*;
import java.io.*;

public class Forward extends Thread {
    private Semaphore sem;

    InputStream _in;
    OutputStream _out;

    public Forward(Semaphore sem, InputStream in, OutputStream out) {
	_in = in;
	_out = out;
	this.sem = sem;
    }

    public void run() {
	int count;
	byte buf[] = new byte[4096];

	try {
	    while((count = _in.read(buf)) != -1) {
		if (count == 0) {
		    Log.err("Only read 0 bytes!");
		}
		_out.write(buf, 0, count);
		_out.flush();
		//Log.log("flushed " + count + " bytes.");
	    }

	    _out.close();

	} catch (SocketException e) {
	    // Do nothing. We expect this.
	} catch (Exception e) {
	    Log.err(e);
	}

	sem.v();
	Log.log("Forward exited");
    }
}
