package windsock;

import windsock.*;
import java.io.*;
import java.net.*;

public class Log {
    static DatagramSocket sock;
    static InetAddress logHost;

    static {
	try {
	    if (Config.logHost != null) {
		logHost = InetAddress.getByName(Config.logHost);
		sock = new DatagramSocket();
		System.out.println("Remote logging initialized");
	    }
	} catch (IOException e) {
	    System.err.println(e);
	}
    }

    public static String getPrefix() {
	return Thread.currentThread().getName() + " (" +
		System.currentTimeMillis() + "): ";
    }

    public static void log(String s) {
	output(System.out, getPrefix() + s);
    }

    public static void log(Object o) {
	log(o.toString());
    }

    public static void err(String s) {
	output(System.err, getPrefix() + s);
    }

    public static void err(Object o) {
	err(o.toString());
    }

    protected static void output(PrintStream stream, String s) {
	if (stream != null) {
	    stream.println(s);
	}
	if (sock != null) {
	    byte[] buf = (s + "\n").getBytes();
	    DatagramPacket packet = new DatagramPacket(buf, buf.length,
		    logHost, Config.logPort);
	    try {
		sock.send(packet);
	    } catch (IOException e) {
		// It's UDP. What do you expect?
	    }
	}
    }
}
