package windsock;

import windsock.*;

public class Request {
    byte command;
    byte addressType;
    byte[] address;
    int port;

    public String toString() {
	String s = "[Request ";
	switch (command) {
	    case SocksSocket.CMD_CONNECT:
		s += "connect";
		break;
	    case SocksSocket.CMD_BIND:
		s += "bind";
		break;
	    case SocksSocket.CMD_UDP_ASSOC:
		s += "UDP associate";
		break;
	    default:
		s += command;
		break;
	}

	s += ", ";
	switch (addressType) {
	    case SocksSocket.ATYP_IPV4:
		s += "IPv4: " +
			Util.unsigned(address[0]) + "." +
			Util.unsigned(address[1]) + "." +
			Util.unsigned(address[2]) + "." +
			Util.unsigned(address[3]);
		break;
	    case SocksSocket.ATYP_DOMAIN:
		s += "domain: " + new String(address);
		break;
	    case SocksSocket.ATYP_IPV6:
		s += "IPv6: " + address;
		break;
	}

	s += ", " + port + "]";

	return s;
    }
}
