package windsock;

import windsock.*;
import java.net.*;
import java.io.*;

public class Server {
    public static void main(String[] args) {
	ServerSocket serverSocket = null;
	int port = 1080;

	Log.log("Java SOCKS server");

	try {
	    serverSocket = new ServerSocket(port);
	} catch (IOException e) {
	    Log.err("Could not listen on port " + port + ".");
	    Log.err(e);
	    System.exit(1);
	}

	while (true) {
	    Socket client = null;

	    Log.log("Waiting for client connection...");
	    try {
		client = serverSocket.accept();
	    } catch (IOException e) {
		System.err.println("Accept failed.");
		System.err.println(e);
		System.exit(1);
	    }

	    Log.log("Connect from " + client);

	    try {
		Thread handler = new ClientHandler(client);
		handler.start();
	    } catch (IOException e) {
		Log.err(e);
	    }
	}
    }
}
